/*
tuya_iot_config.h
Copyright(C),2018-2020, 涂鸦科技 www.tuya.comm
*/

/* AUTO-GENERATED FILE. DO NOT MODIFY !!!
*
* This config file is automatically generated by tuya cross-build system.
* It should not be modified by hand.
*/

#ifndef TUYA_IOT_CONFIG_H
#define TUYA_IOT_CONFIG_H

#ifdef __cplusplus
extern "C" {
#endif

/* default definitons */

#define SYSTEM_SMALL_MEMORY_BEGIN       0       /*small memory systems begin */
#define SYSTEM_REALTEK8710_1M           1
#define SYSTEM_REALTEK8710_2M           2
#define SYSTEM_NON_OS					3		/*no operating system*/
#define SYSTEM_FREERTOS                 98
#define SYSTEM_SMALL_MEMORY_END         99      /*small memory systems end */
#define SYSTEM_LINUX                    100
#define SYSTEM_LITEOS                   120

#define TLS_DISABLE                     0       /* disable tls function */
#define TLS_TUYA_PSK_ONLY               2       /* only enable ciper 0xAE */
#define TLS_TUYA_ECC_PSK                3       /* enable ciper 0xAE && 0xC027 */
#define TLS_TUYA_ECC_ONLY               4       /* only enable ciper 0xC027 */
#define TLS_TUYA_ECC_ONLY_NOSTRIP       5       /* only enable ciper 0xC027, but enable most of mbed-tls configs */
#define TLS_TUYA_ECC_CLIENT_AUTH        6       /* TLS Client Authentication and Server Authentication mode */


#define TUYA_OPERATOR_DISABLE           0x0
#define TUYA_OPERATOR_CUCC              0x01
#define TUYA_OPERATOR_CTCC              0x02
#define TUYA_OPERATOR_CMCC              0x04
#define TUYA_OPERATOR_CMCC_ANDLINK      0x08
#define TUYA_OPERATOR_ALL               (TUYA_OPERATOR_CUCC | TUYA_OPERATOR_CTCC | TUYA_OPERATOR_CMCC)

#define TUYA_LAN_V31                    0x1
#define TUYA_LAN_V32                    0x2
#define TUYA_LAN_V33                    0x4
#define TUYA_LAN_V35                    0x8
#define TUYA_LAN_ALL                    (TUYA_LAN_V31 | TUYA_LAN_V32 | TUYA_LAN_V33 | TUYA_LAN_V35)

#define TUYA_MQ_V21                     0x1
#define TUYA_MQ_V22                     0x2
#define TUYA_MQ_V23                     0x4
#define TUYA_MQ_ALL                     (TUYA_MQ_V21 | TUYA_MQ_V22 | TUYA_MQ_V23)

/* custom settings */
#define BUILD_DATE           "2022_01_10"
#define BUILD_TIME           "18_26_59"
#define GIT_USER             "ci_manage"
#define IOT_SDK_VER          "0.0.12"
#define SDK_BETA_VER         ""
#define TARGET_PLATFORM      "anyka3918ev300s"
#define PROJECT_NAME         "tuyaos-ipc"
#define SDK_ID               "tuyaos-ipc_0.0.12_anyka3918ev300s_wifi_0.1.8"
#define KERNEL_VER	        ""
// Generated by Tuya (https://www.tuya.com)


//
// this is low power Kconfig
//

#define LOW_POWER_ENABLE 0

#define INTEGRATE_CUSTOME_MBEDTLS 0


//
// this is tuya monitor Kconfig
//

#define ENABLE_MONITOR_WORK 0


//
// this is tuya local storage Kconfig
//

#define ENABLE_LOCAL_STORAGE 1


//
// this is tuya ai Kconfig
//

#define ENABLE_AI_DETECT 1

#define ENABLE_FACE_DETECTION 1


//
// this is media service Kconfig
//

#define TUYA_P2P 4

#define TUYA_P2P 4

#define ENABLE_CLOUD_STREAM 1

#define ENABLE_MQTT_P2P 1

#define ENABLE_MQTT_WEBRTC 1


//
// this is ipc core Kconfig
//

#define ENABLE_VIDEO_MSG 1


//
// this is tuya cloud operation Kconfig
//

#define ENABLE_CLOUD_OPERATION 1

#define NEW_HTTP_MANAGER 1


//
// TUYAOS kernel configure tkl sw timer
//

// CONFIG_ENABLE_TKL_SW_TIMER is not set


//
// TUYAOS kernel configure timer
//

// CONFIG_ENABLE_TIMER is not set


//
// TUYAOS kernel configure wired
//

// CONFIG_ENABLE_WIRED is not set


//
// TUYAOS kernel configure spi
//

// CONFIG_ENABLE_SPI is not set


//
// TUYAOS kernel configure i2c
//

// CONFIG_ENABLE_I2C is not set


//
// TUYAOS kernel configure gpio
//

// CONFIG_ENABLE_GPIO is not set


//
// TUYAOS kernel configure pwm
//

// CONFIG_ENABLE_PWM is not set


//
// TUYAOS kernel configure display
//

// CONFIG_ENABLE_DISPLAY is not set


//
// TUYAOS kernel configure adc
//

// CONFIG_ENABLE_ADC is not set


//
// TUYAOS kernel configure
//

#define OPERATING_SYSTEM 100

#define LITTLE_END 1

#define ENABLE_FILE_SYSTEM 1


//
// TUYAOS kernel configure bluetooth
//

// CONFIG_ENABLE_BLUETOOTH is not set


//
// TUYAOS kernel configure uart
//

// CONFIG_ENABLE_UART is not set


//
// TUYAOS kernel configure flash
//

// CONFIG_ENABLE_FLASH is not set

// CONFIG_ENABLE_LWIP is not set


//
// TUYAOS kernel configure wi-fi
//

#define ENABLE_WIFI 1

// CONFIG_ENABLE_WIFI_HOSTAP is not set


//
// TUYAOS abstraction configure network protocol
//

// CONFIG_ENABLE_TUYA_LWIP is not set


//
// TUYAOS kernel configure rtc
//

// CONFIG_ENABLE_RTC is not set


//
// TUYAOS kernel configure watchdog
//

// CONFIG_ENABLE_WATCHDOG is not set

// CONFIG_TUYA_HOSTAPD_SUPPORT is not set


//
// TUYAOS kernel configure tkl Zigbee
//

// CONFIG_ENABLE_TKL_ZIGBEE is not set


//
// this is cloud stg Kconfig
//

#define ENABLE_REMOTE_EVENT 1

#define ENABLE_CLOUD_STORAGE 1


//
// this is ipc Kconfig
//

#define ENABLE_IPC 1

#define LOW_POWER_ENABLE 0

#define DB_EN_OLD_VER 0

#define IPC_SDK_VER "5.2.0"

#define ENABLE_IPC_GW_BOTH 0


//
// this is ring buffer Kconfig
//

#define IPC_DEVICE_NUM 1

#define IPC_CHANNEL_NUM 1


//
// TUYAOS TAL configure bluetooth
//

#define TAL_BLUETOOTH 1


//
// TUYAOS old Marco configure
//

#define ENABLE_COMPATIBLE 1

#define KV_FILE 1

#define TUYA_IOT_DEBUG 1

#define ENABLE_LAN_ENCRYPTION 1

#define TLS_MODE 4

#define TLS_SESSION 1

// CONFIG_QRCODE_ACTIVE_MODE is not set

#define TY_RTC 1

#define TY_WATCHDOG 0


//
// 使能无线模式
//

#define WIFI_GW 1

#define ENABLE_AP_FAST_CONNECT 1

#define TY_GET_RFTEST_STAT 0


//
// 开启蓝牙功能
//

// CONFIG_TY_BT_MOD is not set


//
// TUYAOS kernel configure multi-media
//

// CONFIG_ENBALE_MEDIA is not set
#ifndef TUYA_LAN_VERSION
#define TUYA_LAN_VERSION TUYA_LAN_V35
#endif

#ifndef TUYA_MQ_VERSION
#define TUYA_MQ_VERSION TUYA_MQ_V23
#endif

#ifndef ENABLE_DEVICE_DATA_COLLECT
#define ENABLE_DEVICE_DATA_COLLECT 0
#endif

#ifndef TUYA_WEAK_ATTRIBUTE
#define TUYA_WEAK_ATTRIBUTE __attribute__ ((weak))
#endif

/* custom settings */

#ifdef __cplusplus
}
#endif


#endif
