#ifndef __TY_SYS_AV_H__
#define __TY_SYS_AV_H__

#ifdef __cplusplus
extern "C" {
#endif

#include "tal_audio.h"
#include "tal_media.h"
#include "tal_video_enc.h"
#include "tal_video_in.h"

/**
 * @brief
 *
 */
typedef enum
{
    E_DSP_MEDIA_VIDEO_MAIN = 0,    ///< 主码流
    E_DSP_MEDIA_VIDEO_SUB,         ///< 子码流
    E_DSP_MEDIA_VIDEO_3RD,         ///< 第三路码流
    E_DSP_MEDIA_VIDEO_4TH,         ///< 第四路码流
    E_DSP_MEDIA_VIDEO_SNAP,        ///< 抓图
    E_DSP_MEDIA_VIDEO_MD,          ///< 动检
    E_DSP_MEDIA_VIDEO_HD,          ///< 人形
    E_DSP_MEDIA_VIDEO_QR,          ///< 二维码
    E_DSP_MEDIA_VIDEO_MAX,

    E_DSP_MEDIA_VIDEO_EX = 100,    ///< 以下为扩展类型 不占用编码通道
    E_DSP_MEDIA_VIDEO_EX_SNAP,     ///< 抓图扩展类型，不带OSD抓图 */
} E_DSP_MEDIA_VIDEO_TYPE;

/**
 * @brief 音频流
 *
 */
typedef enum
{
    E_DSP_MEDIA_AUDIO = 0,        ///<
    E_DSP_MEDIA_AUDIO_2RD,        ///<
    E_DSP_MEDIA_AUDIO_3RD,        ///<
    E_DSP_MEDIA_AUDIO_4TH,        ///<
    E_DSP_MEDIA_AUDIO_CNT_MAX,    ///<
} E_DSP_MEDIA_AUDIO_TYPE;

/**
 * @brief
 *
 */
#define TY_DSP_MEDIA_AUDIO_MAX 4

/**
 * @brief
 *
 */
#define TY_DSP_MEDIA_VI_MAX 2

/**
 * @brief
 *
 */
#define TY_DSP_MEDIA_VENC_MAX 5

/**
 * @brief
 *
 */
#define TY_DSP_MEDIA_YUV_MAX 3

/**
 * @brief
 *
 */
typedef struct
{
    TAL_AUDIO_CONFIG_T audio[TY_DSP_MEDIA_AUDIO_MAX];                        ///<
    TAL_VI_CONFIG_T vi[TY_DSP_MEDIA_VI_MAX];                                 ///<
    TAL_VENC_CONFIG_T venc[TY_DSP_MEDIA_VENC_MAX + TY_DSP_MEDIA_YUV_MAX];    ///<
    TAL_VENC_CONFIG_T *yuv;                                                  ///<
} S_DSP_MEDIA_INFO;

/**
 * @brief 
 * 
 * @return S_DSP_MEDIA_INFO* 
 */
S_DSP_MEDIA_INFO *ty_sys_av_get_system_info();

/**
 * @brief 
 * 
 * @return int 
 */
int ty_sys_av_start();

/**
 * @brief 
 * 
 * @return int 
 */
int ty_sys_av_stop();

#ifdef __cplusplus
}    // extern "C"
#endif

#endif    // __TY_SYS_AV_H__
