#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <stdio.h>
#include <libgen.h>
#include <signal.h>
#include <sys/prctl.h>
#include <sys/time.h>
#include <pthread.h>
#include <sys/types.h>
#include <dirent.h>
#include "ty_time.h"
#include "isp_common_config.h"
#include "isp_day_config.h"
#include "ty_log.h"
#include "ty_sys_av.h"
#include "ty_dsp_adapter.h"
#include "tuya_jpeg_utils.h"
#include "tuya_rgb_utils.h"
#include "tuya_yuv_utils.h"

//#define TEST_VENC_MAIN_SUB
//#define TEST_AI_VQE
// #define TEST_SNAP
// #define TEST_MD
// #define TEST_QR
// #define TEST_MORROR_FLIP
// #define TEST_OSD
// #define TEST_HD
// #define TEST_PERI
// #define TEST_AI
// #define TEST_YUV_SCALE_JPEG  // yuv缩放编码
// #define TEST_FORMAT

int bind_ch = -1;
// #define TEST_AO

// #include "ty_dsp_adapter.h"
#ifndef MAX_MEDIA_FRAME_SIZE
#define MAX_MEDIA_FRAME_SIZE (300 * 1024)
#endif
#define APP_SYS_AV_AUDIO_FRAME_SIZE      (640) // 16000*2/25=1280  8000*2/25=640 ak帧长:512(pcm),256(g711u)
#define APP_SYS_AV_VIDEO_FRAME_SIZE_100K (640 * 360 * 3 / 2) // 子码流最大100k
typedef struct {
    int init;
    int stat;
    pthread_t pid;
    int param;
} TY_SYS_THREAD_INFO_S;

typedef struct {
    int seiEnable;
    char *pbuf;
} TY_SYS_SEI_INFO_S;

typedef struct {
    TY_SYS_THREAD_INFO_S videoThreadInfo[TY_DSP_MEDIA_VENC_MAX];
    TY_SYS_THREAD_INFO_S audioThreadInfo[TY_DSP_MEDIA_AUDIO_MAX];
    TY_SYS_SEI_INFO_S seiInfo;
    S_DSP_MEDIA_INFO *pstrDspInfo;
} TY_SYS_AV_S;

extern S_DSP_MEDIA_INFO gMediaInfo;
static TY_SYS_AV_S s_sys_av_cfg = {0};

TY_SYS_AV_S *__get_sys_av_handle()
{
    return &s_sys_av_cfg;
}

S_DSP_MEDIA_INFO *ty_sys_av_get_system_info()
{
    gMediaInfo.yuv = gMediaInfo.venc + TY_DSP_MEDIA_VENC_MAX + 1;
    return &gMediaInfo;
}

unsigned long int CurTimeInMsec()
{
    struct timeval tv;
    if (gettimeofday(&tv, NULL) < 0) {
        return 0;
    }
    return tv.tv_sec * 1000 + tv.tv_usec / 1000;
}

void *__audio_task(void *args)
{
    TY_SYS_AV_S *pHandle = __get_sys_av_handle();
    S_DSP_MEDIA_INFO *pDspInfo = pHandle->pstrDspInfo;
    int type = *(int *)args;
    int send_cnt = 1;
    // int typeOffset = E_IPC_STREAM_AUDIO_MAIN;
    char thName[64];
    sprintf(thName, "__audio_task_%d", type);
    prctl(PR_SET_NAME, thName);

    TYDEBUG("__begin type = %d\n", type);
    char *frame_buff = (char *)malloc(APP_SYS_AV_AUDIO_FRAME_SIZE);
    if (NULL == frame_buff) {
        TYERROR("malloc failed type = %d\n", type);
        return NULL;
    }

    // TYINFO("ty_time_wait_sync wait start,type:%d...\n", type);
    // ty_time_wait_sync();    //等待时间同步完成，避免osd叠加1970的时间戳
    TYINFO("ty_time_wait_sync end,type:%d...\n", type);
#ifdef TEST_AI
    FILE *fp = NULL;
#endif
    char path[128];
    snprintf(path, 128, "test_audio_%d_%lu.pcm", type, CurTimeInMsec());

    while (true == pHandle->audioThreadInfo[type].stat) {
        // todo
        // get av from dsp and put data to sdk
        if (send_cnt % 500 == 0) {
            TYINFO("loop_cnt = %d type = %d\n", send_cnt, type);
        }
        //  time0 = ty_sdk_uni_time_get_posix_ms();
        if (pDspInfo->audio[type].enable) {
            TAL_AUDIO_FRAME_INFO_T frame = {0};
            frame.pbuf = frame_buff;
            frame.buf_size = APP_SYS_AV_AUDIO_FRAME_SIZE;
            if (0 == ty_dsp_audio_get(type, &frame)) {
#ifdef TEST_AI
                if (fp != NULL) {
                    fwrite(frame.pbuf, 1, frame.used_size, fp);
                    fflush(fp);
                } else {
                    TYINFO("fopen %s\n", path);
                    fp = fopen(path, "ab+");
                }
#endif
                send_cnt++;
            }
        }
        usleep(10 * 1000);
    }

    return NULL;
}

void *__video_task(void *args)
{
    TY_SYS_AV_S *pHandle = __get_sys_av_handle();
    int type = *(int *)args;
    int send_cnt = 1;
    int bufSize = 0;
    char *frame_buff = NULL;
    // int typeOffset = E_IPC_STREAM_VIDEO_MAIN;
    // E_DSP_HD_DETECT_RESULT result={0};
    TAL_VENC_FRAME_T frame = {0};

    char thName[64];
    sprintf(thName, "__video_task_%d", type);
    prctl(PR_SET_NAME, thName);

    // 主码流
    if (type == 0) {
        bufSize = MAX_MEDIA_FRAME_SIZE;
    } else {
        bufSize = APP_SYS_AV_VIDEO_FRAME_SIZE_100K;
    }

    TYDEBUG("__begin type = %d\n", type);
    frame_buff = (char *)malloc(bufSize);
    if (NULL == frame_buff) {
        TYERROR("malloc failed type = %d\n", type);
        return NULL;
    }

    frame.pbuf = frame_buff;
    frame.buf_size = bufSize;
    TYINFO("wait time sync start,type:%d...\n", type);
    // while (ty_time_get_sync_state() == 0) {
    // tal_venc_get_frame(0, type, &frame); //取一帧并且丢掉，不关心是否成功
    usleep(20 * 1000);
    // }
    // 时间同步后进行 强制I帧
    // E_DSP_MEDIA_VIDEO_SET_IDR_TYPE setIdrType = E_DSP_MEDIA_VIDEO_REQUEST_IDR;
    // ty_dsp_video_set(0,type,E_DSP_SET_VIDEO_IDR,(void*)&setIdrType);

    unsigned long long time_last = ty_time_tick_ms();
    int tmp = 0;
#if (defined TEST_VENC_MAIN_SUB) // || (defined TEST_QR) || (defined TEST_MD)
    FILE *fp = NULL;
#endif
    char path[128];
    if (type == 0) {
        snprintf(path, 128, "test_video_%d_%lu.h265", type, CurTimeInMsec());
    } else {
        snprintf(path, 128, "test_video_%d_%lu.h264", type, CurTimeInMsec());
    }

    char path_md[128];
    char path_qr[128];
    if (type == 1) {
        snprintf(path_md, 128, "test_md_%d_%d_%lu.yuv", gMediaInfo.venc[E_DSP_MEDIA_VIDEO_MD].width,
                 gMediaInfo.venc[E_DSP_MEDIA_VIDEO_MD].height, CurTimeInMsec());
        snprintf(path_qr, 128, "test_qr_%d_%d_%lu.yuv", gMediaInfo.venc[E_DSP_MEDIA_VIDEO_QR].width,
                 gMediaInfo.venc[E_DSP_MEDIA_VIDEO_QR].height, CurTimeInMsec());
    }

    while (true == pHandle->videoThreadInfo[type].stat) {
        // todo
        // get av from dsp and put data to sdk
        if (send_cnt % 500 == 0) {
            TYINFO("loop_cnt = %d type = %d\n", send_cnt, type);
            if (type == 0 || type == 1) {
                tmp = (ty_time_tick_ms() - time_last) / 1000;
                TYINFO("          type = %d, fps:%.1f\n", type, 500.0 / tmp);
                time_last = ty_time_tick_ms();
            }
        }

        if (0 == tal_venc_get_frame(0, type, &frame)) {
#ifdef TEST_VENC_MAIN_SUB
            if (fp != NULL) {
                fwrite(frame.pbuf, 1, frame.used_size, fp);
                fflush(fp);
            } else {
                fp = fopen(path, "ab+");
            }
#endif
            send_cnt++;
        }

#ifdef TEST_MD
        if (type == 1) {

            if (0 == tal_venc_get_frame(0, E_DSP_MEDIA_VIDEO_MD, &frame)) {
                FILE *fp_md = fopen(path_md, "ab+");
                if (fp_md != NULL) {
                    fwrite(frame.pbuf, 1, frame.used_size, fp_md);
                    fclose(fp_md);
                }
            }
        }
#endif

#ifdef TEST_QR
        if (type == 1) {

 
            if (0 == tal_venc_get_frame(0, E_DSP_MEDIA_VIDEO_QR, &frame)) {
                FILE *fp_qr = fopen(path_qr, "ab+");
                if (fp_qr != NULL) {
                    fwrite(frame.pbuf, 1, frame.used_size, fp_qr);
                    fclose(fp_qr);
                }
            }
        }
#endif
        usleep(10 * 1000);
    }

    return NULL;
}
#define YUV_LEN (640*368*3/2)
char yuv_buf[YUV_LEN];
static int ty_sys_av_video_frame_put(TKL_VENC_CHN_E chn, TKL_VENC_FRAME_T *frame)
{
    int frameLen = frame->used_size;
    static int send_cnt[2] = {0};
    static uint64_t time_last[2] = {0};
    static int len[2] = {0};

    if (chn < 2 && send_cnt[chn] == 0) {
        time_last[chn] = ty_time_tick_ms();
    }

    if ((frame == NULL) || (frame->pbuf == NULL)) {
        printf("ty_sys_av_video_frame_put frame:%p", frame);
        return -1;
    }

    if (frameLen > MAX_MEDIA_FRAME_SIZE || frame->pbuf == NULL) {
        TYERROR("ERROR!!! frameLen= %d,MAX_MEDIA_FRAME_SIZE = %d,frame.pbuf =%p\n", frameLen, MAX_MEDIA_FRAME_SIZE,
                frame->pbuf);
        return -1;
    }

#ifdef TEST_FORMAT
    if (chn == 0 && send_cnt[chn] == 100) {
        TKL_VENC_FORMAT_T format = {0};
        format.width = 1280;
        format.height = 720;
        format.codectype = TKL_CODEC_VIDEO_H264;
        format.h264_attr.bitrate = 1024;
        format.h264_attr.fps = 24;
        format.h264_attr.gop = format.h264_attr.fps * 2;
        format.h264_attr.profile = TKL_VENC_H264_PROFILE_BASELINE;

        if (0 != tal_venc_set(0, E_DSP_MEDIA_VIDEO_MAIN, TAL_VENC_CMD_FORMAT, &format)) {
            printf("tal_venc_set TAL_VENC_CMD_FORMAT wrong\n");
        }
    }
#endif

    if (chn < 2) {
        len[chn] = len[chn] + frame->used_size;
        send_cnt[chn]++;

        if (send_cnt[chn] % 100 == 0) {
            int tmp = (ty_time_tick_ms() - time_last[chn]);
            TYINFO("chn = %d, send_cnt:%d, fps:%.1f, time:%lu ms len:%d kbps\n", chn, send_cnt[chn], 1000*100.0 / tmp, tmp, len[chn] * 8 / tmp);
            len[chn] = 0;
            time_last[chn] = ty_time_tick_ms();
        }
    }

#ifdef TEST_VENC_MAIN_SUB
    static FILE *fp[2] = {0};
    char path[128];
    if (chn == 0) {
        snprintf(path, 128, "test_video_cb_%d_%lu.h265", chn, CurTimeInMsec());
    } else {
        snprintf(path, 128, "test_video_cb_%d_%lu.h264", chn, CurTimeInMsec());
    }

    if (fp[chn] != NULL) {
        fwrite(frame->pbuf, 1, frame->used_size, fp[chn]);
        fflush(fp[chn]);
    } else {
        fp[chn] = fopen(path, "ab+");
        printf("open path:%s\n", path);
    }
#endif

#ifdef TEST_QR
        if (chn == 1) {
            char path_qr[128];
            snprintf(path_qr, 128, "test_qr_%d_%d_%lu.yuv", gMediaInfo.venc[E_DSP_MEDIA_VIDEO_QR].width,
                 gMediaInfo.venc[E_DSP_MEDIA_VIDEO_QR].height, CurTimeInMsec());
                 frame->pbuf = yuv_buf;
                 frame->buf_size = YUV_LEN; 
            if (0 == tal_venc_get_frame(0, E_DSP_MEDIA_VIDEO_QR, frame)) {
                FILE *fp_qr = fopen(path_qr, "ab+");
                if (fp_qr != NULL) {
                    fwrite(frame->pbuf, 1, frame->used_size, fp_qr);
                    fclose(fp_qr);
                }
            }
        }
#endif

#ifdef TEST_MD
        if (chn == 1) {
            char path_md[128];
            snprintf(path_md, 128, "test_md_%d_%d_%lu.yuv", gMediaInfo.venc[E_DSP_MEDIA_VIDEO_MD].width,
                 gMediaInfo.venc[E_DSP_MEDIA_VIDEO_MD].height, CurTimeInMsec());
            frame->pbuf = yuv_buf;
            frame->buf_size = YUV_LEN; 
            if (0 == tal_venc_get_frame(0, E_DSP_MEDIA_VIDEO_MD, frame)) {
                FILE *fp_md = fopen(path_md, "ab+");
                if (fp_md != NULL) {
                    fwrite(frame->pbuf, 1, frame->used_size, fp_md);
                    fclose(fp_md);
                }
            }
        }
#endif

    return 0;
}

static int ty_sys_av_frame_put_main(TKL_VENC_FRAME_T *frame)
{
    int ret = ty_sys_av_video_frame_put(0, frame);
    return ret;
}

static int ty_sys_av_frame_put_sub(TKL_VENC_FRAME_T *frame)
{
    int ret = ty_sys_av_video_frame_put(1, frame);
    return ret;
}

int ty_sys_av_start()
{
    TYDEBUG("__begin\n");
    int ret = 0;
    int i = 0;
    TY_SYS_AV_S *pHandle = __get_sys_av_handle();
    pthread_attr_t attr = {0};
    int size = 1024 * 1024;
    TAL_VI_CONFIG_T *pvi = NULL;

    pHandle->seiInfo.pbuf = NULL;

    // config vi,isp,当前ipc设备只有一路vi
    pvi = &gMediaInfo.vi[0];
    pvi->enable = true;
    pvi->chn = TKL_VI_0;
    pvi->mirror = ISP_SENSOR_MIRROR;
    pvi->filp = ISP_SENSOR_FILP;
    memcpy(pvi->isp.conf, ISP_SENSOR_CONF, sizeof(pvi->isp.conf));
    memcpy(pvi->isp.version, ISP_FW_VERSION, sizeof(pvi->isp.version));
    memcpy(pvi->isp.name, ISP_SENSOR_NAME, sizeof(pvi->isp.name));
    pvi->isp.width = ISP_SENSOR_WIDTH;
    pvi->isp.height = ISP_SENSOR_HEIGHT;
#ifdef ISP_SENSOR_FPS
    pvi->isp.fps = ISP_SENSOR_FPS; // 默认sensor 帧率20fps，如果定义配置，则以配置为准
#endif
    memcpy(&pvi->isp.isp_dn_switch_config, &g_Tuya_DN_SWITCH_CONFIG_DAY, sizeof(pvi->isp.isp_dn_switch_config));
    pvi->isp.isp_fig_style_day.brightness = 50;
    pvi->isp.isp_fig_style_day.saturation = 50;
    pvi->isp.isp_fig_style_day.contrast = 50;
    pvi->isp.isp_fig_style_day.sharpness = 50;
    pvi->isp.isp_fig_style_day.gamma = 50;
    pvi->isp.isp_fig_style_night = pvi->isp.isp_fig_style_day;

    TYDEBUG("pvi->isp.isp_fig_style_day brightness %u saturation %u contrast %u sharpness %u gamma %u\n",
            pvi->isp.isp_fig_style_day.brightness, pvi->isp.isp_fig_style_day.saturation,
            pvi->isp.isp_fig_style_day.contrast, pvi->isp.isp_fig_style_day.sharpness,
            pvi->isp.isp_fig_style_day.gamma);

    // get dsp info
    pHandle->pstrDspInfo = ty_sys_av_get_system_info();

    // pHandle->pstrDspInfo->cbParam.audioPutCB = ty_sys_av_audio_frame_put;
    // pHandle->pstrDspInfo->cbParam.videoPutCB = ty_sys_av_video_frame_put;

    // 创建码流获取线程，抓图码流不在其中
    for (i = 0; i < E_DSP_MEDIA_VIDEO_3RD /*E_DSP_MEDIA_VIDEO_SNAP*/; i++) {
        if (pHandle->pstrDspInfo->venc[i].enable == 0) {
            continue;
        }

        if (pHandle->pstrDspInfo->venc[i].trans_mode == TKL_VENC_PUSH_FRAME_BY_CALLBACK) {
            pHandle->pstrDspInfo->venc[i].put_cb = (i == 0) ? (ty_sys_av_frame_put_main) : (ty_sys_av_frame_put_sub);
        } else {
            pHandle->videoThreadInfo[i].param = i;
            pHandle->videoThreadInfo[i].stat = true;
            pthread_attr_init(&attr);
            pthread_attr_setstacksize(&attr, size);

            ret = pthread_create(&pHandle->videoThreadInfo[i].pid, &attr, __video_task,
                                 &pHandle->videoThreadInfo[i].param);
            if (0 != ret) {
                TYERROR("pthread create failed\n");
                pHandle->audioThreadInfo[i].stat = false;
                pthread_attr_destroy(&attr);
                return -1;
            }
            pthread_attr_destroy(&attr);
            pHandle->videoThreadInfo[i].init = 1;
        }
    }

    for (i = 0; i < TY_DSP_MEDIA_AUDIO_MAX; i++) {
        if (pHandle->pstrDspInfo->audio[i].enable == 0) {
            continue;
        }
        pHandle->audioThreadInfo[i].param = i;
        pHandle->audioThreadInfo[i].stat = true;
        pthread_attr_t attr;
        int size = 1024 * 1024;
        pthread_attr_init(&attr);
        pthread_attr_setstacksize(&attr, size);
        ret = pthread_create(&pHandle->audioThreadInfo[i].pid, &attr, __audio_task, &pHandle->audioThreadInfo[i].param);
        if (0 != ret) {
            TYERROR("pthread create failed\n");
            pHandle->audioThreadInfo[i].stat = false;
            pthread_attr_destroy(&attr);
            return -1;
        }
        pthread_attr_destroy(&attr);
        pHandle->audioThreadInfo[i].init = 1;
    }
    ret = ty_dsp_init(pHandle->pstrDspInfo);
    if (0 != ret) {
        TYERROR("####failed\n");
        return -1;
    }
    TYDEBUG("__end\n");
    return 0;
}

int ty_sys_av_snap_test(int num)
{
    TAL_VENC_FRAME_T frame = {0};
    int bufSize = 150 * 1024;

    TYDEBUG("ty_sys_av_snap_test num %d\n", num);
    frame.pbuf = (char *)malloc(bufSize);
    if (NULL == frame.pbuf) {
        TYERROR("malloc failed\n");
        return -1;
    }
    frame.buf_size = bufSize;
    char path[128];
    FILE *fp = NULL;

    while (num > 0) {
        if (0 == tal_venc_get_frame(0, E_DSP_MEDIA_VIDEO_SNAP, &frame)) {
            snprintf(path, 128, "test_snap_%d_%lu.jpeg", num, CurTimeInMsec());
            fp = fopen(path, "ab+");
            if (fp != NULL) {
                fwrite(frame.pbuf, 1, frame.used_size, fp);
                fflush(fp);
                fclose(fp);
            }
            num--;
            TYDEBUG("get pic success\n");
        }
        sleep(1);
    }
    free(frame.pbuf);
    return 0;
}
#if 0
static int __scale_enc_jpeg(uint8_t *ch_org, uint8_t *ch_out, uint8_t *buf_jpeg, int dst_width, int dst_height)
{
    int org_width = 640;
    int org_height = 368; // 360;
    int org_stride = 640;
    char path[128];
    FILE *fp = NULL;
    enum YUV_CONVERT_TYPE dst_type = YUV_CONVERT_TYPE_NV12;
    TYDEBUG("want to get pic:%d %d\n", dst_width, dst_height);
    int ret = yuv_scale_frame_semi(ch_org, ch_out, org_width, org_height, org_stride, dst_width, dst_height, dst_type);
    if (ret != 0) {
        TYERROR("yuv_scale_frame_semi failed\n");
        return -1;
    }

    // w file
    //  snprintf(path, 128, "test_snap_%d_%d_%lu.yuv", dst_width, dst_height, CurTimeInMsec());
    //  fp = fopen(path, "ab+");
    //  if (fp != NULL) {
    //      fwrite(ch_out, 1, dst_width*dst_height*3/2, fp);
    //      fflush(fp);
    //      fclose(fp);
    //  }
    // TYDEBUG("get yuv success:%s\n", path);

    // jpeg编码
    unsigned char *src_yuv = ch_out;
    int quality = 50;
    int dst_len = 0;
    ret = tuya_jpeg_encode_from_nv12(src_yuv, dst_width, dst_height, quality, &buf_jpeg, &dst_len);
    if (ret != 0) {
        TYERROR("tuya_jpeg_encode_from_nv12 failed\n");
        return -1;
    }

    // w file
    snprintf(path, 128, "test_snap_%d_%d_%lu.jpeg", dst_width, dst_height, CurTimeInMsec());
    TYDEBUG("get jpeg success:%s, over\n", path);
    fp = fopen(path, "ab+");
    if (fp != NULL) {
        fwrite(buf_jpeg, 1, dst_len, fp);
        fflush(fp);
        fclose(fp);
    }

    return 0;
}

// 640*368 缩放成：1920*1080,1280*720,480*270,320*240
int ty_sys_yuv_scale_jpeg_test()
{
    TAL_VENC_FRAME_T frame = {0};
    int bufSize_1080p = 1920 * 1080 * 3 / 2;
    int bufSize_360p = 640 * 368 * 3 / 2;
    int bufSize_jpeg = 300 * 1024;
    unsigned char *buf_1080p = NULL;
    unsigned char *buf_jpeg = NULL;

    sleep(1);
    TYDEBUG("ty_sys_yuv_scale_jpeg_test\n");
    frame.pbuf = (char *)malloc(bufSize_360p);
    if (NULL == frame.pbuf) {
        TYERROR("malloc failed\n");
        return -1;
    }

    buf_1080p = (unsigned char *)malloc(bufSize_1080p);
    if (NULL == buf_1080p) {
        TYERROR("malloc failed\n");
        return -1;
    }

    buf_jpeg = (unsigned char *)malloc(bufSize_jpeg);
    if (NULL == buf_jpeg) {
        TYERROR("malloc failed\n");
        return -1;
    }

    frame.buf_size = bufSize_360p;
    char path[128];
    FILE *fp = NULL;

    if (0 == tal_venc_get_frame(0, E_DSP_MEDIA_VIDEO_QR, &frame)) {
        snprintf(path, 128, "test_snap_640_368_%lu.yuv", CurTimeInMsec());
        fp = fopen(path, "ab+");
        if (fp != NULL) {
            fwrite(frame.pbuf, 1, frame.used_size, fp);
            fflush(fp);
            fclose(fp);
        }
        TYDEBUG("get yuv success:%s\n", path);
    }

    // yuv 缩放到1080p
    uint8_t *ch_org = (uint8_t *)frame.pbuf;
    uint8_t *ch_out = buf_1080p;

    // 1920*1080,1280*720,480*270,320*240
    __scale_enc_jpeg(ch_org, ch_out, buf_jpeg, 1920, 1080);
    __scale_enc_jpeg(ch_org, ch_out, buf_jpeg, 1280, 720);
    __scale_enc_jpeg(ch_org, ch_out, buf_jpeg, 640, 360);
    __scale_enc_jpeg(ch_org, ch_out, buf_jpeg, 480, 270);
    __scale_enc_jpeg(ch_org, ch_out, buf_jpeg, 320, 180);

    free(frame.pbuf);
    free(buf_1080p);
    free(buf_jpeg);
    return 0;
}
#endif
int ty_sys_ao_test()
{
    ty_dsp_audio_play_file("beep_A.wav", 1, 3, 1000);
    return 0;
}

int ty_sys_ai_vqe_test()
{
    int ret = 0;
    TAL_AUDIO_VQE_PARAM_T param;
    param.enable = 0;
    ret = tal_ai_set(0, 0, TAL_AI_CMD_VQE_AEC, &param);
    if (ret < 0) {
        printf("ty_sys_aq_vqe_test wrong\n");
    }

    return 0;
}

int ty_sys_osd_test()
{
    TKL_VENC_OSD_T osd = {0};
    osd.enable = 1;
    osd.is_dls = 0;
    tal_venc_set(0, 0, TAL_VENC_CMD_OSD, &osd);
    printf("osd test enable:%d, is dls:%d\n", osd.enable, osd.is_dls);
    sleep(3);

    osd.enable = 0;
    osd.is_dls = 0;
    tal_venc_set(0, 0, TAL_VENC_CMD_OSD, &osd);
    printf("osd test enable:%d, is dls:%d\n", osd.enable, osd.is_dls);
    sleep(3);

    osd.enable = 1;
    osd.is_dls = 1;
    tal_venc_set(0, 0, TAL_VENC_CMD_OSD, &osd);
    printf("osd test enable:%d, is dls:%d\n", osd.enable, osd.is_dls);
    sleep(3);

    osd.enable = 1;
    osd.is_dls = 0;
    tal_venc_set(0, 0, TAL_VENC_CMD_OSD, &osd);
    printf("osd test enable:%d, is dls:%d\n", osd.enable, osd.is_dls);
    sleep(3);
    printf("********************* osd test over **********************\n");

    return 0;
}

int ty_sys_morror_flip_test()
{
    TKL_VI_MIRROR_FLIP_E val = TKL_VI_MIRROR_FLIP_NONE;
    tal_vi_set(0, TAL_VI_CMD_MIRROR_FLIP, &val);
    printf("morror_flip_test :%d\n", val);
    sleep(3);

    val = TKL_VI_FLIP;
    tal_vi_set(0, TAL_VI_CMD_MIRROR_FLIP, &val);
    printf("morror_flip_test :%d\n", val);
    sleep(3);

    val = TKL_VI_MIRROR;
    tal_vi_set(0, TAL_VI_CMD_MIRROR_FLIP, &val);
    printf("morror_flip_test :%d\n", val);
    sleep(3);

    val = TKL_VI_MIRROR_FLIP;
    tal_vi_set(0, TAL_VI_CMD_MIRROR_FLIP, &val);
    printf("morror_flip_test :%d\n", val);
    sleep(3);
    printf("********************* ty_sys_morror_flip_test over **********************\n");

    return 0;
}

static char *__load_nn_models(char *modelPath, int *pout_len)
{
    int32_t readLen;
    int32_t fileLen;
    FILE *fp;

    if (!(fp = fopen(modelPath, "rb"))) {
        printf("Error[FH_NN]: open %s failed\n", modelPath);
        return NULL;
    }

    fseek(fp, 0, SEEK_END);
    fileLen = ftell(fp);
    fseek(fp, 0, SEEK_SET);

    char *buf = malloc(fileLen);
    if (buf == NULL) {
        printf("Error[FH_NN]: malloc model buf failed, size = %d\n", fileLen);
        fclose(fp);
        return NULL;
    }

    readLen = fread(buf, 1, fileLen, fp);
    if (readLen < fileLen) {
        printf("Error[FH_NN]: read model file failed, fileLen = %d, readLen = %d\n", fileLen, readLen);
        free(buf);
        buf = NULL;
    }
    *pout_len = readLen;
    fclose(fp);
    return buf;
}

static void __free_nn_models(char *buf)
{
    free(buf);
}

void *__hd_task(void *args)
{
    (void)args;
    char thName[64] = "__hd_task";
    prctl(PR_SET_NAME, thName);
    int i = 0;
    int ret = -1;
    int num = 10;
//    int flag = 0;

    TKL_VI_DETECT_CONFIG_T config = {0};
    config.pmodel = __load_nn_models("c2det_2102602_CH2_person_pet.nbg", &config.model_len);
    if (config.pmodel == NULL) {
        printf("func:%s line:%d person_pet.nbg\n", __func__, __LINE__);
        return NULL;
    }
//AGAIN:
    ret = tkl_vi_detect_init(0, TKL_MEDIA_DETECT_TYPE_HUMAN, &config);
    if (ret < 0) {
        printf("tkl_vi_detect_init :failed %d\n", ret);
        return NULL;
    }

    ret = tkl_vi_detect_start(0, TKL_MEDIA_DETECT_TYPE_HUMAN);
    if (ret < 0) {
        printf("tkl_vi_detect_start :failed %d\n", ret);
    }
    TKL_VI_DETECT_RESULT_T result = {0};
    TYDEBUG("main ty_sys_av_hd_test start %s line:%d\n", __func__, __LINE__);
    while (num > 0) {
        if (tkl_vi_detect_get_result(0, TKL_MEDIA_DETECT_TYPE_HUMAN, &result) < 0) {
            printf("tkl_vi_detect_get_result failed\n");
        } else {
            printf("[%d] tkl_vi_detect_get_result result:%d\n", num, result.count);
            for (i = 0; i < result.count; i++) {
                printf("    result[%d] type:%d, conf:%f, box:x y w h:%f,%f,%f,%f\n", i, result.target[i].type,
                       result.target[i].score, result.target[i].draw_rect.x, result.target[i].draw_rect.y,
                       result.target[i].draw_rect.width, result.target[i].draw_rect.height);
            }
        }
        usleep(1000 * 1000);
        num --;
    }
#if 0
    if (flag == 0) {
        num = 10;
        tkl_vi_detect_stop(0, TKL_MEDIA_DETECT_TYPE_HUMAN);
        tkl_vi_detect_uninit(0, TKL_MEDIA_DETECT_TYPE_HUMAN);
        __free_nn_models(config.pmodel);
        config.pmodel = __load_nn_models("c2det_ddr_cost_down.nbg", &config.model_len);
        if (config.pmodel == NULL) {
            printf("func:%s line:%d person_pet.nbg\n", __func__, __LINE__);
            return NULL;
        }
        flag = 1;
        goto AGAIN;
    }
#endif    
    __free_nn_models(config.pmodel);

    return NULL;
}

int ty_sys_av_hd_test()
{
    pthread_attr_t attr;
    int size = 1024 * 1024;
    int ret = -1;
    pthread_t pid = 0;
    pthread_attr_init(&attr);
    pthread_attr_setstacksize(&attr, size);
    ret = pthread_create(&pid, &attr, __hd_task, NULL);
    if (0 != ret) {
        TYERROR("pthread create failed\n");
        pthread_attr_destroy(&attr);
        return -1;
    }
    pthread_attr_destroy(&attr);
    return 0;
}

static void *__peri_task(void *args)
{
    (void)args;
    char thName[64] = "__peri_task";
    prctl(PR_SET_NAME, thName);
    int i = 0;
    int ret = -1;

    ret = tkl_vi_detect_init(0, TKL_MEDIA_DETECT_TYPE_PERI, NULL);
    if (ret < 0) {
        printf("tkl_vi_detect_init :failed %d\n", ret);
        return NULL;
    }

    ret = tkl_vi_detect_start(0, TKL_MEDIA_DETECT_TYPE_PERI);
    if (ret < 0) {
        TYERROR("tkl_vi_detect_start failed\n");
        return NULL;
    }

    TKL_VI_DETECT_RESULT_T result = {0};
    TYDEBUG("main ty_sys_av_peri_test start %s line:%d\n", __func__, __LINE__);
    while (1) {
        if (tkl_vi_detect_get_result(0, TKL_MEDIA_DETECT_TYPE_PERI, &result) < 0) {
            printf("tkl_vi_detect_get_result failed\n");
        } else {
            printf("tkl_vi_detect_get_result result:%d\n", result.count);
            for (i = 0; i < result.count; i++) {
                printf("    result[%d] type:%d, conf:%f, box:x y w h:%f,%f,%f,%f\n", i, result.target[i].type,
                       result.target[i].score, result.target[i].draw_rect.x, result.target[i].draw_rect.y,
                       result.target[i].draw_rect.width, result.target[i].draw_rect.height);
            }
        }
        usleep(1000 * 1000);
    }
    return NULL;
}

int ty_sys_av_peri_test()
{
    pthread_attr_t attr;
    int size = 1024 * 1024;
    int ret = -1;
    pthread_t pid = 0;
    pthread_attr_init(&attr);
    pthread_attr_setstacksize(&attr, size);
    ret = pthread_create(&pid, &attr, __peri_task, NULL);
    if (0 != ret) {
        TYERROR("pthread create __peri_task failed\n");
        pthread_attr_destroy(&attr);
        return -1;
    }
    pthread_attr_destroy(&attr);
    return 0;
}

int ty_sys_isp_test()
{
    // 图像黑屏
#if 0
    INT32_T illumin_result = 0;
    tkl_vi_dnswitch_get_illumin(0, 0, &illumin_result);

    TKL_ISP_FLICKER_TYPE_E eAntiFlicker = 0;
    tkl_vi_isp_set_antiflicker(0, eAntiFlicker);

    TKL_ISP_DN_MODE_E irmode = 0;
    tkl_vi_isp_set_color_to_gray(0, irmode);

    tkl_vi_isp_load_isp_file(irmode);

    TKL_ISP_LOG_INFO_T pstISPParam;
    tkl_vi_isp_get_param(0, &pstISPParam);
#endif
    return 0;
}

extern int tkl_nn_detect(char *p_data, int w, int h, TKL_VI_DETECT_RESULT_T *p_result);

void rgb_to_bgra(unsigned char *src, unsigned char *dest, int w)
{
    int j = 0;
    unsigned char *p_dest = dest;
    for (j = 0; j < w; j++) {
        p_dest[0] = src[0];
        p_dest[1] = src[1];
        p_dest[2] = src[2];
        p_dest[3] = 0xff;
        p_dest += 4;
        src += 3;
    }
    return;
}
#if 0
static void jpeg_memory_test(unsigned char *buffer, int buffer_len)
{
    int width = 0;
    int height = 0;
    char *rgb_buffer = NULL;
    int rgb_len = 0;
    char *argb_buffer = NULL;
    int argb_len = 0;

    rgb_len = 640 * 360 * 3;
    rgb_buffer = (char *)malloc(rgb_len);
    if (!rgb_buffer) {
        printf("malloc rgb_len:%d failed.\n", rgb_len);
        return;
    }

    printf("memory statistics begin.\n");
    // tuya_jpeg_decode_to_rgb  //tuya_jpeg_decode_to_bgr
    if (tuya_jpeg_decode_to_rgb(buffer, buffer_len, &width, &height, (unsigned char **)&rgb_buffer, &rgb_len) < 0) {
        printf("tuya_jpeg_decode_to_rgb failed.\n");
        return;
    }

    printf("tuya_jpeg_decode_to_rgb end., w h:%d %d\n", width, height);

    argb_len = 512 * 288 * 4;
    argb_buffer = (char *)malloc(argb_len);
    if (!argb_buffer) {
        printf("malloc argb_len:%d failed.\n", argb_len);
        return;
    }
#if 0
    rgb_to_bgra(rgb_buffer, argb_buffer, 512*288);
       TKL_VI_DETECT_RESULT_T result;
    tkl_nn_detect(argb_buffer, width, height, &result);
#else
    TUYA_CONVERT_IMAGE_INFO_T image = {0};
    image.src_pixel = TUYA_PIXEL_FORMAT_TYPE_RGB888;
    image.src_width = width;
    image.src_height = height;
    image.src_stride = width * 3;
    image.src_image = rgb_buffer;

    image.dst_pixel = TUYA_PIXEL_FORMAT_TYPE_ARGB8888;
    image.dst_width = 512;
    image.dst_height = 288;
    image.dst_stride = 512 * 4;
    image.dst_len = image.dst_stride * image.dst_height;
    image.dst_image = argb_buffer;
    memset(image.dst_image, 0, image.dst_len);
    tuya_rgb_convert(&image);

    // TKL_VI_DETECT_RESULT_T result;
    //  tkl_nn_detect(argb_buffer, image.dst_width, image.dst_height, &result);
#endif

    if (rgb_buffer) {
        free(rgb_buffer);
        rgb_buffer = NULL;
    }

    if (argb_buffer) {
        free(argb_buffer);
        argb_buffer = NULL;
    }

    return;
}

int nn_test_jpg()
{
    int buffer_len = 0;
    unsigned char *buffer = NULL;
    char filename[32];
    int i = 0;

    while (1) {
        sprintf(filename, "pic%d.jpg", i++);
        FILE *file = fopen(filename, "rb+");
        if (file == NULL) {
            printf("open failed:%s \n", filename);
            return -1;
        }
        printf("nn_test open %s\n", filename);

        fseek(file, 0, SEEK_END);
        buffer_len = ftell(file);
        fseek(file, 0, SEEK_SET);
        buffer = (unsigned char *)malloc(sizeof(unsigned char) * buffer_len);

        fread(buffer, buffer_len, 1, file);
        fclose(file);

        jpeg_memory_test(buffer, buffer_len);
        printf("\n");
    }
    return 0;
}

int nn_test_jpg_dir(char *dir)
{
    DIR *p_root_dir = NULL;
    struct dirent *p_child_dir = NULL;
    int buffer_len = 0;
    unsigned char *buffer = NULL;

    p_root_dir = opendir(dir);
    if (p_root_dir == NULL) {
        printf("nn_test_jpg_dir open %s failed\n", dir);
        return 0;
    }
    // int str_len = 0;
    // char *p = NULL;

    while ((p_child_dir = readdir(p_root_dir)) != NULL) {
        if (strcmp(p_child_dir->d_name, ".") == 0 || strcmp(p_child_dir->d_name, "..") == 0 ||
            strcmp(p_child_dir->d_name, "dsp_demo_fh8636") == 0) {
            continue;
        }
        // str_len = strlen(p_child_dir->d_name);
        // p = p_child_dir->d_name + str_len-5;
        // if (p[0] !='.' || p[1] !='j' || p[2] !='p'|| p[3] !='g'){
        //     printf("no support %s\n", p_child_dir->d_name);
        //     continue;
        // }

        printf("nn_test open %s\n", p_child_dir->d_name);
        FILE *file = fopen(p_child_dir->d_name, "rb+");
        if (file == NULL) {
            printf("open failed:%s \n", p_child_dir->d_name);
            continue;
        }

        fseek(file, 0, SEEK_END);
        buffer_len = ftell(file);
        fseek(file, 0, SEEK_SET);
        buffer = (unsigned char *)malloc(sizeof(unsigned char) * buffer_len);

        fread(buffer, buffer_len, 1, file);
        fclose(file);

        jpeg_memory_test(buffer, buffer_len);
        if (buffer) {
            free(buffer);
            buffer = NULL;
        }

        printf("\n");
    }
    closedir(p_root_dir);
    return 0;
}

int nn_test_rgb(char *filename)
{
    int buffer_len = 0;
    char *buffer = NULL;
    FILE *file = fopen(filename, "rb+");
    if (file == NULL) {
        printf("open failed:%s \n", filename);
        return -1;
    }
    printf("nn_test open %s\n", filename);

    fseek(file, 0, SEEK_END);
    buffer_len = ftell(file);
    fseek(file, 0, SEEK_SET);
    buffer = (char *)malloc(sizeof(char) * buffer_len);

    if (buffer_len != 512 * 288 * 4) {
        printf("not support\n");
        return -1;
    }

    fread(buffer, buffer_len, 1, file);
    fclose(file);

    //   TKL_VI_DETECT_RESULT_T result;
    //  tkl_nn_detect(buffer, 512, 288, &result);

    return 0;
}
#endif
#ifdef TEST_OSD
static OPERATE_RET __time_cb(struct tm *p_tm)
{
    if (NULL == p_tm) {
        printf("invalid param\n");
        return OPRT_INVALID_PARM;
    }
    time_t currTime;
    time(&currTime);
    struct tm *p_currDate = localtime((time_t *)&currTime);
    printf("currTime:%ld\n", currTime);
    *p_tm = *p_currDate;
    return OPRT_OK;
}
#endif

int main(int argc, char **argv)
{
    (void)argc;
    (void)argv;
    printf("[%s, %d,%s, %s]\n", __FUNCTION__, __LINE__, __DATE__, __TIME__);

    if (argv[1] != NULL) {
        bind_ch = atoi(argv[1]);
    }
    TYDEBUG("bind_ch :%d\n", bind_ch);
    ty_sys_av_start();
    usleep(100 * 1000);
    TYDEBUG("main ty_sys_av_start\n");

#ifdef TEST_AO
    ty_sys_ao_test();
#endif

#ifdef TEST_AI_VQE
    ty_sys_ai_vqe_test();
#endif

#ifdef TEST_MORROR_FLIP
    ty_sys_morror_flip_test();
#endif

#ifdef TEST_OSD
    tal_venc_set_time_cb(__time_cb);
    ty_sys_osd_test();
#endif

#ifdef TEST_SNAP
    ty_sys_av_snap_test(5);
#endif

#ifdef TEST_PERI
    ty_sys_av_peri_test();
#endif

#ifdef TEST_HD
    ty_sys_av_hd_test();
#endif

#ifdef TEST_YUV_SCALE_JPEG
    ty_sys_yuv_scale_jpeg_test();
#endif

#ifdef TEST_FORMAT
    TKL_VENC_FORMAT_T format = {0};
    int i = 0;
    for (i = 0; i < E_DSP_MEDIA_VIDEO_MAX; i++) {
        if (0 != tal_venc_get(0, i, TAL_VENC_CMD_FORMAT, &format)) {
            printf("tal_venc_get TAL_VENC_CMD_FORMAT wrong\n");
        } else {
            printf("[%d] w h code:%d %d %d\n", i, format.width, format.height, format.codectype);
        }
    }

#endif

    ty_sys_isp_test();
#if 0
    printf("./dsp_demo rgba_filename or ./dsp_demo or ./dsp_demo dir\n");

    if (argv[1] != NULL){
        //nn_test_rgb(argv[1]);
        nn_test_jpg_dir(argv[1]);
    } else {
        nn_test_jpg();
    }
#else
    while (1) {
        sleep(1);
    }
    return 0;
#endif
}

OPERATE_RET tuya_ipc_get_utc_time(OUT TIME_T *time_utc)
{
    if(NULL == time_utc) {
        printf("invalid param");
        return OPRT_INVALID_PARM;
    }
    time((time_t *)time_utc);
    return OPRT_OK;
}