///////////////////////////////////////////////////////////////////////////////
// KalmanTracker.h: KalmanTracker Class Declaration

#ifndef KALMAN_H
#define KALMAN_H 2

#include "mat.h"

typedef struct {
    float x;
    float y;
    float width;
    float height;
} KALMAN_RECT;

typedef struct {
    int m_time_since_update; //每次调用predict函数的时候就会+1,每次调用update函数的时候就会设置为0
    int m_hits;
    int m_hit_streak;
    int m_age;
    int m_id;
    KALMAN_RECT lastRect;
} KALMAN_FILETER_STATE;

typedef struct {
    int type;       //跟踪目标的类型
    float conf;     //跟踪目标的置信度
} KALMAN_PRIV;

// int kalman_tracker_init();
void *kalman_tracker_create(KALMAN_RECT *initRect, KALMAN_PRIV *p_priv);
void kalman_tracker_destory(void *hdl);
void kalman_tracker_update(void *hdl, KALMAN_RECT *stateMat, KALMAN_PRIV *p_priv);
void kalman_tracker_predict(void *hdl, KALMAN_RECT *result);
void kalman_tracker_state(void *hdl, KALMAN_FILETER_STATE *stat, KALMAN_PRIV *p_priv);
void kalman_tracker_reset();

#endif