#ifndef __SORT_HPP__
#define __SORT_HPP__

#include <unistd.h>
#include "KalmanTracker.h"

#define MAX_TRACKERS_NUM 10

typedef struct {
    float x;
    float y;
    float width;
    float height;
} SORT_BOX;

typedef struct{
    int frame;
    unsigned int id;
    SORT_BOX box;
    int b_match;    //为了适应追踪场景会将所有追踪器目标无论是否匹配均返回，通过此项判断当前目标是否被匹配
    KALMAN_PRIV priv; // 私有参数
} SORT_TRACKING_ITEM;

typedef struct{
    int num;
    SORT_TRACKING_ITEM item[MAX_TRACKERS_NUM];
} SORT_TRACKING_LIST;


typedef struct{
    int max_age;
    int min_hits;
    float iou_thrs;
} SORT_PARAM;

int sort_tracker_init(void **phdl, SORT_PARAM *para);
int sort_tracker_update(void *hdl, SORT_TRACKING_LIST *in, SORT_TRACKING_LIST *out);
int sort_tracker_deinit();


#endif
