#include <fcntl.h>
#include <unistd.h>
#include <pthread.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <sys/prctl.h>

#include "isp_api.h"
#include "fh_system_mpi.h"
#include "fh_vpu_mpi.h"
#include "mpp/fh_vb_mpi.h"
#include "fh_venc_mpi.h"
#include "debug.h"

#ifdef FH_APP_USING_COOLVIEW
#include "dbi_over_tcp.h"

static struct dbi_tcp_config g_dbi_tcp_conf;
static volatile int g_coolview_is_running;
static volatile int g_stop_coolview;

FH_SINT32 sample_common_start_coolview(void)
{
    pthread_attr_t attr;
    struct sched_param param;

    if (g_coolview_is_running) {
        printf("Error: coolview is already running!\n");
        return -1;
    }

    g_stop_coolview = 0;
    g_dbi_tcp_conf.cancel = &g_stop_coolview;
    g_dbi_tcp_conf.port = 8888;

    pthread_attr_init(&attr);
    pthread_attr_setdetachstate(&attr, PTHREAD_CREATE_DETACHED);
    pthread_attr_setstacksize(&attr, 3 * 1024);

    pthread_attr_setschedparam(&attr, &param);

    pthread_t thread_dbg;
    int ret = -1;
    ret = pthread_create(&thread_dbg, &attr, (void *(*)(void *))libtcp_dbi_thread, &g_dbi_tcp_conf);
    if (!ret) {
        g_coolview_is_running = 1;
    } else {
        printf("Error: create coolview thread failed!\n");
    }
    return ret;
}

FH_SINT32 sample_common_stop_coolview(FH_VOID)
{
    if (g_coolview_is_running) {
        /*wait for coolview thread to exit*/
        g_stop_coolview = 1;
        g_coolview_is_running = 0;
    }

    return 0;
}
#endif
