/*
* imx415_mipi.h
*
* Created on Mar 02 2022
*     Generated by sensorcodeGen
*/
#ifndef IMX415_MIPI_H_
#define IMX415_MIPI_H_

#ifndef XGM
#include "cfg/imx415_mipi_4lane_800wp30_wdr.h"
#include "cfg/imx415_mipi_2lane_800wp20.h"
#include "cfg/imx415_mipi_2lane_800wp15.h"
#include "cfg/imx415_mipi_4lane_800wp15_wdr.h"
// #include "cfg/imx415_mipi_4lane_800wp20_wdr.h"
#include "cfg/imx415_mipi_4lane_12bit_800wp20_wdr.h"
#else
#include "cfg/imx415_mipi_2lane_800wp30.h"
#include "cfg/imx415_mipi_4lane_12bit_800wp30_wdr.h"
#endif

static SNS_CONFIG_S stSnsConf0[]  =
{
#ifdef XGM
    {
        .u32SnsFmt        = FORMAT_800WP30,
        .u32ConfSize      = sizeof(Sensor_Cfg_IMX415_MIPI_2LANE_800WP30) / 4,
        .pu16CciConf      = Sensor_Cfg_IMX415_MIPI_2LANE_800WP30,
        .u8MipiClkRate    = R_1500_1999,
        .u8MipiLaneNum    = 2,
        .stSnsAttr        = &attr_2l_800wp30,
        .u32SnsClk        = 27000000,
    },

    {
        .u32SnsFmt        = FORMAT_WDR_800WP30,
        .u32ConfSize      = sizeof(Sensor_Cfg_IMX415_MIPI_4LANE_12BIT_WDR_800WP30) / 4,
        .pu16CciConf      = Sensor_Cfg_IMX415_MIPI_4LANE_12BIT_WDR_800WP30,
        .u8MipiClkRate    = R_1500_1999,
        .u8MipiLaneNum    = 4,
        .stSnsAttr        = &attr_4l_12bit_wdr_800wp30,
        .u32SnsClk        = 27000000,
    },
#else
    {
        .u32SnsFmt        = FORMAT_WDR_800WP30,
        .u32ConfSize      = sizeof(Sensor_Cfg_IMX415_MIPI_4LANE_WDR_800WP30) / 4,
        .pu16CciConf      = Sensor_Cfg_IMX415_MIPI_4LANE_WDR_800WP30,
        .u8MipiClkRate    = R_1400_1499,
        .u8MipiLaneNum    = 4,
        .stSnsAttr        = &attr_4l_wdr_800wp30,
        .u32SnsClk        = 24000000,
    },
    {
        .u32SnsFmt        = FORMAT_800WP20,
        .u32ConfSize      = sizeof(Sensor_Cfg_IMX415_MIPI_2LANE_800WP20) / 4,
        .pu16CciConf      = Sensor_Cfg_IMX415_MIPI_2LANE_800WP20,
        .u8MipiClkRate    = R_1400_1499,
        .u8MipiLaneNum    = 2,
        .stSnsAttr        = &attr_2l_800wp20,
        .u32SnsClk        = 24000000,
    },
    {
        .u32SnsFmt        = FORMAT_800WP15,
        .u32ConfSize      = sizeof(Sensor_Cfg_IMX415_MIPI_2LANE_800WP15) / 4,
        .pu16CciConf      = Sensor_Cfg_IMX415_MIPI_2LANE_800WP15,
        .u8MipiClkRate    = R_1400_1499,
        .u8MipiLaneNum    = 2,
        .stSnsAttr        = &attr_2l_800wp15,
        .u32SnsClk        = 24000000,
    },
    // {
    //     .u32SnsFmt        = FORMAT_WDR_800WP20,
    //     .u32ConfSize      = sizeof(Sensor_Cfg_IMX415_MIPI_4LANE_WDR_800WP20) / 4,
    //     .pu16CciConf      = Sensor_Cfg_IMX415_MIPI_4LANE_WDR_800WP20,
    //     .u8MipiClkRate    = R_1400_1499,
    //     .u8MipiLaneNum    = 4,
    //     .stSnsAttr        = &attr_4l_wdr_800wp20,
    //     .u32SnsClk        = 24000000,
    // },
    {
        .u32SnsFmt        = FORMAT_WDR_800WP20,
        .u32ConfSize      = sizeof(Sensor_Cfg_IMX415_MIPI_4LANE_12BIT_WDR_800WP20) / 4,
        .pu16CciConf      = Sensor_Cfg_IMX415_MIPI_4LANE_12BIT_WDR_800WP20,
        .u8MipiClkRate    = R_1400_1499,
        .u8MipiLaneNum    = 4,
        .stSnsAttr        = &attr_4l_12bit_wdr_800wp20,
        .u32SnsClk        = 24000000,
    },
    {
        .u32SnsFmt        = FORMAT_WDR_800WP15,
        .u32ConfSize      = sizeof(Sensor_Cfg_IMX415_MIPI_4LANE_WDR_800WP15) / 4,
        .pu16CciConf      = Sensor_Cfg_IMX415_MIPI_4LANE_WDR_800WP15,
        .u8MipiClkRate    = R_1400_1499,
        .u8MipiLaneNum    = 4,
        .stSnsAttr        = &attr_4l_wdr_800wp15,
        .u32SnsClk        = 24000000,
    },
#endif
};

const unsigned int IMX415RegToGain[241] =
{
    64,66,69,71,73,76,79,82,84,87,90,94,97,100,104,107,
    111,115,119,123,128,132,137,142,147,152,157,163,168,
    174,180,187,193,200,207,214,222,230,238,246,255,264,
    273,283,293,303,313,324,336,348,360,373,386,399,413,
    428,443,458,474,491,508,526,545,564,584,604,625,647,
    670,694,718,743,769,797,825,853,883,915,947,980,1014,
    1050,1087,1125,1165,1206,1248,1292,1337,1384,1433,1483,
    1535,1589,1645,1703,1763,1825,1889,1955,2024,2095,2169,
    2245,2324,2405,2490,2578,2668,2762,2859,2959,3063,3171,
    3282,3398,3517,3641,3769,3901,4038,4180,4327,4479,4637,
    4800,4968,5143,5324,5511,5704,5905,6112,6327,6549,6780,
    7018,7264,7520,7784,8057,8340,8633,8936,9250,9575,9912,
    10260,10621,10994,11380,11780,12194,12623,13067,13526,
    14001,14493,15003,15530,16076,16641,17225,17831,18457,
    19106,19777,20472,21192,21937,22708,23506,24332,25187,
    26072,26988,27937,28918,29935,30987,32075,33203,34370,
    35577,36828,38122,39462,40848,42284,43770,45308,46900,
    48548,50255,52021,53849,55741,57700,59728,61827,64000,
    66249,68577,70987,73482,76064,78737,81504,84368,87333,
    90402,93579,96868,100272,103796,107443,111219,115128,119174,
    123362,127697,132184,136830,141638,146616,151768,157101,162622,
    168337,174253,180377,186715,193277,200069,207100,214378,221912,
    229710,237783,246139,254789,
};//0~72db
#endif /* IMX415_MIPI_H_ */
